//DefineScanner.h: define const,used by asic module;
/* sane - Scanner Access Now Easy.

   Copyright (C) 2005 Mustek.
   Originally maintained by Mustek
   Author:Roy 2005.5.24

   This file is part of the SANE package.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   As a special exception, the authors of SANE give permission for
   additional uses of the libraries contained in this release of SANE.

   The exception is that, if you link a SANE library with other files
   to produce an executable, this does not by itself cause the
   resulting executable to be covered by the GNU General Public
   License.  Your use of that executable is in no way restricted on
   account of linking the SANE library code into it.

   This exception does not, however, invalidate any other reasons why
   the executable file might be covered by the GNU General Public
   License.

   If you submit changes to SANE to the maintainers to be included in
   a subsequent release, you agree by submitting the changes that
   those changes may be distributed with this exception intact.

   If you write modifications of your own for SANE, it is your choice
   whether to permit this exception to apply to your modifications.
   If you do not wish that, delete this exception notice.

   This file implements a SANE backend for Mustek 1200UB and similar 
   USB flatbed scanners.  */
#ifndef _DEFINESCANNER_H_
#define _DEFINESCANNER_H_

#define		DPI_2400		0x8000
#define		DPI_1200		0x8000
#define		DPI_600			0x8000
#define		DPI_300			0x4000
#define		DPI_200			0x2aaa
#define		DPI_150			0x2000
#define		DPI_100			0x1555
#define		DPI_75			0x1000
#define     DPI_50          0xaaa
#define		PIXEL_TIME		333	//unit : ms
#define DRAM_1Mx16_SIZE				(1024*1024)				//unit : word
#define PackAreaStartAddress ((DRAM_1Mx16_SIZE/4)*3)

#define TEMP_MEMORY_SIZE_64K 64*1024

#define CALIBRATION_PIXEL_WIDTH			10240//  need 512x
#define	CALIBRATE_WHITE_LINECOUNT	40
#define	CALIBRATE_DARK_LINECOUNT	2

#define ACTION_MODE_ACCDEC_MOVE 0
#define ACTION_MODE_UNIFORM_SPEED_MOVE 1

#define ACTION_TYPE_BACKWARD 0	//1 Roy
#define ACTION_TYPE_FORWARD  1	//0 Roy
#define ACTION_TYPE_BACKTOHOME 2
#define ACTION_TYPE_TEST_MODE 3


#define SENSOR0_DETECTED 0x10
#define SENSOR1_DETECTED 0x20
#define SENSOR0AND1_DETECTED 0x30

#define READ_RAM	0
#define WRITE_RAM	1

#define EXTERNAL_RAM	0
#define ON_CHIP_PRE_GAMMA	1
#define ON_CHIP_FINAL_GAMMA	2

#define MOTOR_TABLE_SIZE	512*8

#define ValidPixelNumberFor600DPI 5100 + 50 + 250
#define ValidPixelNumberFor1200DPI 10200 + 100 + 500

#define OverLapPixelNumber600 0
#define OverLapPixelNumber1200 0
#define SegmentGap 0
#define	BANK_SIZE	(64)

#define WaitBufferOneLineSize 11000*6

#define CCD_PIXEL_NUMBER   21600
#define CCD_Line_Spacing   24
#define CCD_EvneOdd_Spacing 2

#define	ShadingTableSize(x)			( ((x + 10)*6) + ( ((x + 10)*6)/240)*16 )
#define ACC_DEC_STEP_TABLE_SIZE		(512)					//unit : word
#define TableBase(x)				((((x)+((1<<TABLE_OFFSET_BASE)-1))>>TABLE_OFFSET_BASE)<<TABLE_OFFSET_BASE)
#define NUM_OF_ACC_DEC_STEP_TABLE	(8)						//unit : word
#define TABLE_BASE_SIZE				(1024*2*2*2*2)			//unit : word
#define LAMP0_PWM_DEFAULT            255
#define LAMP1_PWM_DEFAULT            255

#define TABLE_OFFSET_BASE			(14)					//unit : word
#define CHECK_HOME_SLEEP_TIME 100

#define _MOTOR_MOVE_TYPE _4_TABLE_SPACE_FOR_FULL_STEP 


#define TA_CAL_PIXELNUMBER 50000

#define SENSOR_DPI  1200
#define TA_IMAGE_PIXELNUMBER 61000
#define MAX_PATH 256

#endif   //end of #ifndef _DEFINESCANNER_H_
